cscript "betafit predict" adofiles betafit_p
use bench/governing.dta, clear
gen lnpop = ln(popdens)
gen lnhous = ln(houseval)
gen baseline = 1

betafit governing , mu(minorityleft noleft lnhous lnpop) phi(lnpop lnhous minorityleft noleft) 
est store norm
betafit governing , mu(minorityleft noleft lnhous lnpop baseline, nocons) phi(lnpop lnhous minorityleft noleft baseline, nocons)
est store nocons 

if c(stata_version) >= 11 {
	gen byte govern = 1 + minorityleft + 2*noleft
	betafit governing , mu(i.govern lnhous lnpop) phi(i.govern lnhous lnpop)
	est store fv
	betafit governing , alpha(i.govern lnhous lnpop) beta(i.govern lnhous lnpop)
	est store fvab
}

est restore norm
predict pd
predict pp, p
predict mu, mu
assert pd == pp
assert pp == mu

sum pp
assert reldif( r(max)    , .1835317760705948 ) <  1E-6
assert reldif( r(min)    , .0552765391767025 ) <  1E-6
assert reldif( r(sd)     , .019875891525898  ) <  1E-6
assert reldif( r(Var)    , .0003950510639493 ) <  1E-6
assert reldif( r(mean)   , .0949493769956666 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

est restore nocons
predict pd2
predict pp2, p
predict mu2, mu

assert pd == pd2
assert pp == pp2
assert mu == mu2

if c(stata_version) >= 11 {
	est restore fv
	predict pd3
	predict pp3, p
	predict mu3, mu

	assert reldif(pd, pd3) < 1E-7
	assert reldif(pp, pp3) < 1E-7
	assert reldif(mu, mu3) < 1E-7
	drop pd3 pp3 mu3
}

drop pp pd mu pp2 pd2 mu2

est restore norm
predict xb, xb eq(#1)
predict zb, xb eq(#2)

sum xb
assert reldif( r(max)    , -1.492600202560425) <  1E-6
assert reldif( r(min)    , -2.838543653488159) <  1E-6
assert reldif( r(sd)     , .2294759137738101 ) <  1E-6
assert reldif( r(Var)    , .0526591950023251 ) <  1E-6
assert reldif( r(mean)   , -2.275897297068177) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

sum zb
assert reldif( r(max)    , 5.312130928039551 ) <  1E-6
assert reldif( r(min)    , 3.239701509475708 ) <  1E-6
assert reldif( r(sd)     , .3811587383588088 ) <  1E-6
assert reldif( r(Var)    , .1452819838272789 ) <  1E-6
assert reldif( r(mean)   , 4.274568969958296 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

est restore nocons
predict xb2, xb eq(#1)
predict zb2, xb eq(#2)
assert xb == xb2
assert zb == zb2

if c(stata_version) >= 11 {
	est restore fv
	predict xb3, xb eq(#1)
	predict zb3, xb eq(#2)

	assert reldif(xb, xb3) < 1E-7
	assert reldif(zb, zb3) < 1E-7
	drop xb3 zb3
}

drop xb zb xb2 zb2

est restore norm
predict sd, sd
sum sd
assert reldif( r(max)    , .0701078847050667 ) <  1E-6
assert reldif( r(min)    , .0180691499263048 ) <  1E-6
assert reldif( r(sd)     , .0087928517012838 ) <  1E-6
assert reldif( r(Var)    , .0000773142410408 ) <  1E-6
assert reldif( r(mean)   , .0350085698181293 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

est restore nocons
predict sd2, sd
assert sd == sd2

drop sd sd2

est restore norm
predict alpha, alpha
sum alpha
assert reldif( r(max)    , 14.9902229309082  ) <  1E-6
assert reldif( r(min)    , 2.643051147460938 ) <  1E-6
assert reldif( r(sd)     , 2.21872697621081  ) <  1E-6
assert reldif( r(Var)    , 4.922749394965565 ) <  1E-6
assert reldif( r(mean)   , 7.035257512163893 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

predict beta, beta
sum beta
assert reldif( r(max)    , 187.7916564941406 ) <  1E-6
assert reldif( r(min)    , 21.59158325195313 ) <  1E-6
assert reldif( r(sd)     , 27.78705472721806 ) <  1E-6
assert reldif( r(Var)    , 772.1204104134117 ) <  1E-6
assert reldif( r(mean)   , 70.12584563282049 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

predict phi, phi
sum phi
assert reldif( r(max)    , 202.7818756103516 ) <  1E-6
assert reldif( r(min)    , 25.52610397338867 ) <  1E-6
assert reldif( r(sd)     , 29.62895896637641 ) <  1E-6
assert reldif( r(Var)    , 877.8752094312168 ) <  1E-6
assert reldif( r(mean)   , 77.16110314164206 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

est restore nocons
predict alpha2, alpha
predict beta2, beta
predict phi2, phi
assert alpha == alpha2
assert beta == beta2
assert phi == phi2

if c(stata_version) >= 11 {
	est restore fv
	predict alpha3, alpha
	predict beta3, beta
	predict phi3, phi
	
	assert reldif(alpha, alpha3) < 1E-6
	assert reldif(beta, beta3) < 1E-6
	assert reldif(phi, phi3) < 1E-6
	drop alpha3 beta3 phi3
}
drop alpha beta phi alpha2 beta2 phi2

est restore norm
predict pearson, pearson
predict working, working
predict scres, scres

sum pearson
assert reldif( r(max)    , 120.9142837524414 ) <  1E-6
assert reldif( r(min)    , -73.42876434326172) <  1E-6
assert reldif( r(sd)     , 32.13988071758448 ) <  1E-6
assert reldif( r(Var)    , 1032.971932540559 ) <  1E-6
assert reldif( r(mean)   , -.0093988241760183) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

sum working
assert reldif( r(max)    , 2.638642311096191 ) <  1E-6
assert reldif( r(min)    , -.76148521900177  ) <  1E-6
assert reldif( r(sd)     , .4319040201441598 ) <  1E-6
assert reldif( r(Var)    , .1865410826166868 ) <  1E-6
assert reldif( r(mean)   , -.0008533700818561) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

sum scres
assert reldif( r(max)    , 2.793714284896851 ) <  1E-6
assert reldif( r(min)    , -2.949978351593018) <  1E-6
assert reldif( r(sd)     , .9839659649500172 ) <  1E-6
assert reldif( r(Var)    , .9681890201800184 ) <  1E-6
assert reldif( r(mean)   , .0002627580144164 ) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

est restore nocons
predict pearson2, pearson
predict working2, working
predict scres2, scres

assert pearson == pearson2
assert working == working2
assert scres == scres2

if c(stata_version) >= 11 {
	est restore fv
	predict pearson3, pearson
	predict working3, working
	predict scres3, scres
	
	assert reldif(pearson, pearson3) < 1E-6
	assert reldif(working, working3) < 1E-6
	assert reldif(scres, scres3) < 1E-6
	drop pearson3 working3 scres3
}

drop pearson working scres pearson2 working2 scres2

est restore norm
predict parthous, partial var(lnhous)
predict partpop, partial var(lnpop)

sum parthous
assert reldif( r(max)    , 2.857024431228638 ) <  1E-6
assert reldif( r(min)    , -.6967135071754456) <  1E-6
assert reldif( r(sd)     , .4603935309399495 ) <  1E-6
assert reldif( r(Var)    , .2119622033313543 ) <  1E-6
assert reldif( r(mean)   , .2076148356903146 ) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

sum partpop
assert reldif( r(max)    , 2.664844989776611 ) <  1E-6
assert reldif( r(min)    , -.7567218542098999) <  1E-6
assert reldif( r(sd)     , .4462423268149631 ) <  1E-6
assert reldif( r(Var)    , .1991322142412323 ) <  1E-6
assert reldif( r(mean)   , .0796620188185503 ) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

est restore nocons
predict parthous2, partial var(lnhous)
predict partpop2, partial var(lnpop)
assert parthous == parthous2
assert partpop == partpop2

if c(stata_version) >= 11 {
	est restore fv
	predict parthous3, partial var(lnhous)
	predict partpop3, partial var(lnpop)
	
	assert reldif(parthous, parthous3) < 1E-6
	assert reldif(partpop, partpop3) < 1E-6
	drop parthous3 partpop3
}

drop parthous partpop parthous2 partpop2

betafit governing , alpha(minorityleft noleft lnhous lnpop) beta(lnpop lnhous minorityleft noleft) 
est store norm

predict pd
predict pp, p
predict mu, mu
assert pd == pp
assert pp == mu

sum pp
assert reldif( r(max)    , 1.444388508796692 ) <  1E-6
assert reldif( r(min)    , .0515525937080383 ) <  1E-6
assert reldif( r(sd)     , .0702266973878761 ) <  1E-6
assert reldif( r(Var)    , .0049317890260083 ) <  1E-6
assert reldif( r(mean)   , .0985618167182552 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

if c(stata_version) >= 11 {
	est restore fvab
	predict pd2
	predict pp2, prop
	predict mu2, mu
	
	assert reldif(pd, pd2) < 1E-6
	assert reldif(pp, pp2) < 1E-6
	assert reldif(mu, mu2) < 1E-6
	drop pd2 pp2 mu2
	est restore norm
}

drop pd pp mu

predict xb, eq(#1)
predict zb, eq(#2)
predict alpha, alpha
predict beta, beta

assert xb == alpha
assert zb == beta

sum xb
assert reldif( r(max)    , 10.54916763305664 ) <  1E-6
assert reldif( r(min)    , 1.676790952682495 ) <  1E-6
assert reldif( r(sd)     , 2.003315136718771 ) <  1E-6
assert reldif( r(Var)    , 4.013271537006549 ) <  1E-6
assert reldif( r(mean)   , 6.838828492665959 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

sum zb
assert reldif( r(max)    , 118.2010498046875 ) <  1E-6
assert reldif( r(min)    , -.5158907175064087) <  1E-6
assert reldif( r(sd)     , 23.96228474975919 ) <  1E-6
assert reldif( r(Var)    , 574.1910904285417 ) <  1E-6
assert reldif( r(mean)   , 68.42593212300372 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

if c(stata_version) >= 11 {
	est restore fvab
	predict xb2, eq(#1)
	predict zb2, eq(#2)
	predict alpha2, alpha
	predict beta2, beta
	
	assert reldif(xb, xb2) < 1E-6
	assert reldif(zb, zb2) < 1E-6
	assert reldif(alpha, alpha2) < 1E-6
	assert reldif(beta, beta2) < 1E-6
	drop xb2 zb2 alpha2 beta2
	est restore norm
}
drop xb zb alpha beta

predict phi, phi
sum phi
assert reldif( r(max)    , 128.0363616943359 ) <  1E-6
assert reldif( r(min)    , 1.160900235176086 ) <  1E-6
assert reldif( r(sd)     , 25.63560218378784 ) <  1E-6
assert reldif( r(Var)    , 657.1840993254281 ) <  1E-6
assert reldif( r(mean)   , 75.26476057361219 ) <  1E-6
assert         r(sum_w) == 428
assert         r(N)     == 428

if c(stata_version) >= 11 {
	est restore fvab
	predict phi2, phi
	
	assert reldif(phi, phi2) < 1E-6
	drop phi2
	est restore norm
}
drop phi

predict sd, sd
sum sd
assert reldif( r(max)    , .1567154377698898 ) <  1E-6
assert reldif( r(min)    , .0226082447916269 ) <  1E-6
assert reldif( r(sd)     , .014605493529449  ) <  1E-6
assert reldif( r(Var)    , .0002133204412388 ) <  1E-6
assert reldif( r(mean)   , .0362391077915525 ) <  1E-6
assert         r(sum_w) == 427
assert         r(N)     == 427
if c(stata_version) >= 11 {
	est restore fvab
	predict sd2, sd
	
	assert reldif(sd, sd2) < 1E-6
	drop sd2
	est restore norm
}
drop sd

predict pearson, pearson
predict working, working
predict scres, scres

sum pearson
assert reldif( r(max)    , 118.3862075805664 ) <  1E-6
assert reldif( r(min)    , -67.36376953125   ) <  1E-6
assert reldif( r(sd)     , 31.41816176233596 ) <  1E-6
assert reldif( r(Var)    , 987.1008885243095 ) <  1E-6
assert reldif( r(mean)   , -.1402414049102268) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

sum working
assert reldif( r(max)    , 2.933122396469116 ) <  1E-6
assert reldif( r(min)    , -.7439863681793213) <  1E-6
assert reldif( r(sd)     , .4469551027635503 ) <  1E-6
assert reldif( r(Var)    , .1997688638863758 ) <  1E-6
assert reldif( r(mean)   , .0028933005907979 ) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

sum scres
assert reldif( r(max)    , 2.675029516220093 ) <  1E-6
assert reldif( r(min)    , -2.845634937286377) <  1E-6
assert reldif( r(sd)     , .9763593766836172 ) <  1E-6
assert reldif( r(Var)    , .9532776324380213 ) <  1E-6
assert reldif( r(mean)   , .0045702957174727 ) <  1E-6
assert         r(sum_w) == 394
assert         r(N)     == 394

if c(stata_version) >= 11 {
	est restore fvab
	predict pearson2, pearson
	predict working2, working
	predict scres2, scres
	
	assert reldif(pearson, pearson2) < 1E-6
	assert reldif(working, working2) < 1E-6
	assert reldif(scres, scres2) < 1E-6
	drop pearson2 working2 scres2
	est restore norm
}

drop pearson working scres

exit
