cscript "dbetafit " adofiles dbetafit
use bench/governing.dta, clear
gen lnpop = ln(popdens)
gen lnhous = ln(houseval)
gen baseline = 1

betafit governing , mu(minorityleft noleft lnhous lnpop) phi(lnpop lnhous minorityleft noleft) 
est store norm
betafit governing , mu(minorityleft noleft lnhous lnpop baseline, nocons) phi(lnpop lnhous minorityleft noleft baseline, nocons)
est store nocons 
if c(stata_version) >= 11 {
	gen govern = 1 + minorityleft + 2*noleft
	betafit governing , mu(i.govern lnhous lnpop) phi(lnpop lnhous i.govern) 
	est store fv
}

est restore norm
dbetafit
matrix minmax = r(minmax)
matrix sd = r(sd)
matrix unit = r(unit)
matrix marg = r(marg)
matrix maxmarg = r(maxmarg)

est restore nocons
dbetafit
matrix minmax2 = r(minmax)
matrix sd2 = r(sd)
matrix unit2 = r(unit)
matrix marg2 = r(marg)
matrix maxmarg2 = r(maxmarg)

assert mreldif(minmax,minmax2)   < 1E-8
assert mreldif(sd,sd2)           < 1E-8
assert mreldif(unit,unit2)       < 1E-8
assert mreldif(marg,marg2)       < 1E-8
assert mreldif(maxmarg,maxmarg2) < 1E-8

matrix drop minmax2 sd2 unit2 marg2 maxmarg2

assert reldif( r(pr)  , .0937282329481367 ) <  1E-8

tempname T_minmax 
mat `T_minmax' = J(4,2,0)
mat `T_minmax'[1,1] = -.0122157450494415
mat `T_minmax'[1,2] =  .0054517154373255
mat `T_minmax'[2,1] =  .0081965497796507
mat `T_minmax'[2,2] =   .006263390098235
mat `T_minmax'[3,1] =  .0833194802633378
mat `T_minmax'[3,2] =  .0149393541039088
mat `T_minmax'[4,1] = -.0466680993038235
mat `T_minmax'[4,2] =  .0105278423777104
tempname C_minmax
matrix `C_minmax' = r(minmax)
assert mreldif( `C_minmax' , `T_minmax' ) < 1E-8
_assert_streq `"`: rowfullnames `C_minmax''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_minmax''"' `"coef se"'
mat drop `C_minmax' `T_minmax'

tempname T_sd 
mat `T_sd' = J(4,2,0)
mat `T_sd'[1,1] =                  .
mat `T_sd'[1,2] =                  .
mat `T_sd'[2,1] =                  .
mat `T_sd'[2,2] =                  .
mat `T_sd'[3,1] =  .0122877002853963
mat `T_sd'[3,2] =  .0020707332567887
mat `T_sd'[4,1] = -.0086132173801586
mat `T_sd'[4,2] =  .0019012371348352
tempname C_sd
matrix `C_sd' = r(sd)
assert mreldif( `C_sd' , `T_sd' ) < 1E-8
_assert_streq `"`: rowfullnames `C_sd''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_sd''"' `"coef se"'
mat drop `C_sd' `T_sd'

tempname T_unit 
mat `T_unit' = J(4,2,0)
mat `T_unit'[1,1] =                  .
mat `T_unit'[1,2] =                  .
mat `T_unit'[2,1] =                  .
mat `T_unit'[2,2] =                  .
mat `T_unit'[3,1] =  .0484635582244272
mat `T_unit'[3,2] =  .0082436413105468
mat `T_unit'[4,1] = -.0084335998064416
mat `T_unit'[4,2] =  .0018615600799675
tempname C_unit
matrix `C_unit' = r(unit)
assert mreldif( `C_unit' , `T_unit' ) < 1E-8
_assert_streq `"`: rowfullnames `C_unit''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_unit''"' `"coef se"'
mat drop `C_unit' `T_unit'

tempname T_marg 
mat `T_marg' = J(4,2,0)
mat `T_marg'[1,1] =                  .
mat `T_marg'[1,2] =                  .
mat `T_marg'[2,1] =                  .
mat `T_marg'[2,2] =                  .
mat `T_marg'[3,1] =   .048149248154303
mat `T_marg'[3,2] =  .0081087547216825
mat `T_marg'[4,1] = -.0084319026141832
mat `T_marg'[4,2] =  .0018605066406021
tempname C_marg
matrix `C_marg' = r(marg)
assert mreldif( `C_marg' , `T_marg' ) < 1E-8
_assert_streq `"`: rowfullnames `C_marg''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_marg''"' `"coef se"'
mat drop `C_marg' `T_marg'

tempname T_maxmarg 
mat `T_maxmarg' = J(4,2,0)
mat `T_maxmarg'[1,1] =                  .
mat `T_maxmarg'[1,2] =                  .
mat `T_maxmarg'[2,1] =                  .
mat `T_maxmarg'[2,2] =                  .
mat `T_maxmarg'[3,1] =  .1417100458816994
mat `T_maxmarg'[3,2] =   .020408265949176
mat `T_maxmarg'[4,1] = -.0248162817100839
mat `T_maxmarg'[4,2] =  .0051394966547671
tempname C_maxmarg
matrix `C_maxmarg' = r(maxmarg)
assert mreldif( `C_maxmarg' , `T_maxmarg' ) < 1E-8
_assert_streq `"`: rowfullnames `C_maxmarg''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_maxmarg''"' `"coef se"'
mat drop `C_maxmarg' `T_maxmarg'

tempname T_summary 
mat `T_summary' = J(5,5,0)
mat `T_summary'[1,1] =   .434010152284264
mat `T_summary'[1,2] =   .434010152284264
mat `T_summary'[1,3] =  .4962563770413185
mat `T_summary'[1,5] =                  1
mat `T_summary'[2,1] =  .3857868020304568
mat `T_summary'[2,2] =  .3857868020304568
mat `T_summary'[2,3] =  .4873995129457686
mat `T_summary'[2,5] =                  1
mat `T_summary'[3,1] =  .3677724551239292
mat `T_summary'[3,2] =  .3677724551239292
mat `T_summary'[3,3] =  .2550913251519629
mat `T_summary'[3,4] = -.3285040259361267
mat `T_summary'[3,5] =  1.289232730865479
mat `T_summary'[4,1] = -.8111145394614325
mat `T_summary'[4,2] = -.8111145394614325
mat `T_summary'[4,3] =  1.021289011110097
mat `T_summary'[4,4] = -3.688879489898682
mat `T_summary'[4,5] =  1.742394089698792
mat `T_summary'[5,1] =                  1
mat `T_summary'[5,2] =                  1
mat `T_summary'[5,4] =                  1
mat `T_summary'[5,5] =                  1
tempname C_summary
matrix `C_summary' = r(summary)
assert mreldif( `C_summary' , `T_summary' ) < 1E-8
_assert_streq `"`: rowfullnames `C_summary''"' `"minorityleft noleft lnhous lnpop baseline"'
_assert_streq `"`: colfullnames `C_summary''"' `"x mean sd min max"'
mat drop `C_summary' `T_summary'

if c(stata_version) >= 11 {
	est restore fv
	dbetafit
	matrix minmax2  = r(minmax)
	matrix minmax2  = minmax2[2..5,1..2]
	matrix sd2      = r(sd)
	matrix sd2      = sd2[2..5,1..2]
	matrix unit2    = r(unit)
	matrix unit2    = unit2[2..5,1..2]
	matrix marg2    = r(marg)
	matrix marg2    = marg2[2..5,1..2]
	matrix maxmarg2 = r(maxmarg)
	matrix maxmarg2 = maxmarg2[2..5,1..2]

	assert mreldif(minmax,minmax2)   < 1E-8
	assert mreldif(sd,sd2)           < 1E-8
	assert mreldif(unit,unit2)       < 1E-8
	assert mreldif(marg,marg2)       < 1E-8
	assert mreldif(maxmarg,maxmarg2) < 1E-8

	matrix drop minmax2 sd2 unit2 marg2 maxmarg2
}
matrix drop minmax sd unit marg maxmarg

est restore norm
dbetafit, at(minorityleft 0 noleft 0)
matrix minmax = r(minmax)
matrix sd = r(sd)
matrix unit = r(unit)
matrix marg = r(marg)
matrix maxmarg = r(maxmarg)

est restore nocons
dbetafit, at(minorityleft 0 noleft 0)
matrix minmax2 = r(minmax)
matrix sd2 = r(sd)
matrix unit2 = r(unit)
matrix marg2 = r(marg)
matrix maxmarg2 = r(maxmarg)

assert mreldif(minmax,minmax2)   < 1E-8
assert mreldif(sd,sd2)           < 1E-8
assert mreldif(unit,unit2)       < 1E-8
assert mreldif(marg,marg2)       < 1E-8
assert mreldif(maxmarg,maxmarg2) < 1E-8

matrix drop minmax sd unit marg maxmarg minmax2 sd2 unit2 marg2 maxmarg2

assert reldif( r(pr)  , .0959588553572067 ) <  1E-8

tempname T_minmax 
mat `T_minmax' = J(4,2,0)
mat `T_minmax'[1,1] = -.0118531078677442
mat `T_minmax'[1,2] =  .0052875277121232
mat `T_minmax'[2,1] =   .008622113918942
mat `T_minmax'[2,2] =  .0065851025750686
mat `T_minmax'[3,1] =  .0850340789829705
mat `T_minmax'[3,2] =  .0152207656623595
mat `T_minmax'[4,1] =  -.047651384988058
mat `T_minmax'[4,2] =  .0107426623756557
tempname C_minmax
matrix `C_minmax' = r(minmax)
assert mreldif( `C_minmax' , `T_minmax' ) < 1E-8
_assert_streq `"`: rowfullnames `C_minmax''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_minmax''"' `"coef se"'
mat drop `C_minmax' `T_minmax'

tempname T_sd 
mat `T_sd' = J(4,2,0)
mat `T_sd'[1,1] =                  .
mat `T_sd'[1,2] =                  .
mat `T_sd'[2,1] =                  .
mat `T_sd'[2,2] =                  .
mat `T_sd'[3,1] =  .0125490509322131
mat `T_sd'[3,2] =  .0021130592184626
mat `T_sd'[4,1] = -.0087964566426445
mat `T_sd'[4,2] =  .0019410127202366
tempname C_sd
matrix `C_sd' = r(sd)
assert mreldif( `C_sd' , `T_sd' ) < 1E-8
_assert_streq `"`: rowfullnames `C_sd''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_sd''"' `"coef se"'
mat drop `C_sd' `T_sd'

tempname T_unit 
mat `T_unit' = J(4,2,0)
mat `T_unit'[1,1] =                  .
mat `T_unit'[1,2] =                  .
mat `T_unit'[2,1] =                  .
mat `T_unit'[2,2] =                  .
mat `T_unit'[3,1] =  .0494876272100785
mat `T_unit'[3,2] =  .0084090106121691
mat `T_unit'[4,1] = -.0086130194999505
mat `T_unit'[4,2] =  .0019005066396082
tempname C_unit
matrix `C_unit' = r(unit)
assert mreldif( `C_unit' , `T_unit' ) < 1E-8
_assert_streq `"`: rowfullnames `C_unit''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_unit''"' `"coef se"'
mat drop `C_unit' `T_unit'

tempname T_marg 
mat `T_marg' = J(4,2,0)
mat `T_marg'[1,1] =                  .
mat `T_marg'[1,2] =                  .
mat `T_marg'[2,1] =                  .
mat `T_marg'[2,2] =                  .
mat `T_marg'[3,1] =  .0491738129986036
mat `T_marg'[3,2] =   .008274714202077
mat `T_marg'[4,1] = -.0086113245432936
mat `T_marg'[4,2] =  .0018994556424879
tempname C_marg
matrix `C_marg' = r(marg)
assert mreldif( `C_marg' , `T_marg' ) < 1E-8
_assert_streq `"`: rowfullnames `C_marg''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_marg''"' `"coef se"'
mat drop `C_marg' `T_marg'

tempname T_maxmarg 
mat `T_maxmarg' = J(4,2,0)
mat `T_maxmarg'[1,1] =                  .
mat `T_maxmarg'[1,2] =                  .
mat `T_maxmarg'[2,1] =                  .
mat `T_maxmarg'[2,2] =                  .
mat `T_maxmarg'[3,1] =  .1417100458816994
mat `T_maxmarg'[3,2] =   .020408265949176
mat `T_maxmarg'[4,1] = -.0248162817100839
mat `T_maxmarg'[4,2] =  .0051394966547671
tempname C_maxmarg
matrix `C_maxmarg' = r(maxmarg)
assert mreldif( `C_maxmarg' , `T_maxmarg' ) < 1E-8
_assert_streq `"`: rowfullnames `C_maxmarg''"' `"minorityleft noleft lnhous lnpop"'
_assert_streq `"`: colfullnames `C_maxmarg''"' `"coef se"'
mat drop `C_maxmarg' `T_maxmarg'

tempname T_summary 
mat `T_summary' = J(5,5,0)
mat `T_summary'[1,2] =   .434010152284264
mat `T_summary'[1,3] =  .4962563770413185
mat `T_summary'[1,5] =                  1
mat `T_summary'[2,2] =  .3857868020304568
mat `T_summary'[2,3] =  .4873995129457686
mat `T_summary'[2,5] =                  1
mat `T_summary'[3,1] =  .3677724551239292
mat `T_summary'[3,2] =  .3677724551239292
mat `T_summary'[3,3] =  .2550913251519629
mat `T_summary'[3,4] = -.3285040259361267
mat `T_summary'[3,5] =  1.289232730865479
mat `T_summary'[4,1] = -.8111145394614325
mat `T_summary'[4,2] = -.8111145394614325
mat `T_summary'[4,3] =  1.021289011110097
mat `T_summary'[4,4] = -3.688879489898682
mat `T_summary'[4,5] =  1.742394089698792
mat `T_summary'[5,1] =                  1
mat `T_summary'[5,2] =                  1
mat `T_summary'[5,4] =                  1
mat `T_summary'[5,5] =                  1
tempname C_summary
matrix `C_summary' = r(summary)
assert mreldif( `C_summary' , `T_summary' ) < 1E-8
_assert_streq `"`: rowfullnames `C_summary''"' `"minorityleft noleft lnhous lnpop baseline"'
_assert_streq `"`: colfullnames `C_summary''"' `"x mean sd min max"'
mat drop `C_summary' `T_summary'

exit
